<?php

namespace CustomerManagement\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAccountRecycleSearchResult ArrayType
 * @subpackage Arrays
 */
class ArrayOfAccountRecycleSearchResult extends AbstractStructArrayBase
{
    /**
     * The AccountRecycleSearchResult
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \CustomerManagement\StructType\AccountRecycleSearchResult[]
     */
    public $AccountRecycleSearchResult;
    /**
     * Constructor method for ArrayOfAccountRecycleSearchResult
     * @uses ArrayOfAccountRecycleSearchResult::setAccountRecycleSearchResult()
     * @param \CustomerManagement\StructType\AccountRecycleSearchResult[] $accountRecycleSearchResult
     */
    public function __construct(array $accountRecycleSearchResult = array())
    {
        $this
            ->setAccountRecycleSearchResult($accountRecycleSearchResult);
    }
    /**
     * Get AccountRecycleSearchResult value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \CustomerManagement\StructType\AccountRecycleSearchResult[]|null
     */
    public function getAccountRecycleSearchResult()
    {
        return isset($this->AccountRecycleSearchResult) ? $this->AccountRecycleSearchResult : null;
    }
    /**
     * This method is responsible for validating the values passed to the setAccountRecycleSearchResult method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAccountRecycleSearchResult method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAccountRecycleSearchResultForArrayConstraintsFromSetAccountRecycleSearchResult(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAccountRecycleSearchResultAccountRecycleSearchResultItem) {
            // validation for constraint: itemType
            if (!$arrayOfAccountRecycleSearchResultAccountRecycleSearchResultItem instanceof \CustomerManagement\StructType\AccountRecycleSearchResult) {
                $invalidValues[] = is_object($arrayOfAccountRecycleSearchResultAccountRecycleSearchResultItem) ? get_class($arrayOfAccountRecycleSearchResultAccountRecycleSearchResultItem) : sprintf('%s(%s)', gettype($arrayOfAccountRecycleSearchResultAccountRecycleSearchResultItem), var_export($arrayOfAccountRecycleSearchResultAccountRecycleSearchResultItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AccountRecycleSearchResult property can only contain items of type \CustomerManagement\StructType\AccountRecycleSearchResult, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AccountRecycleSearchResult value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \CustomerManagement\StructType\AccountRecycleSearchResult[] $accountRecycleSearchResult
     * @return \CustomerManagement\ArrayType\ArrayOfAccountRecycleSearchResult
     */
    public function setAccountRecycleSearchResult(array $accountRecycleSearchResult = array())
    {
        // validation for constraint: array
        if ('' !== ($accountRecycleSearchResultArrayErrorMessage = self::validateAccountRecycleSearchResultForArrayConstraintsFromSetAccountRecycleSearchResult($accountRecycleSearchResult))) {
            throw new \InvalidArgumentException($accountRecycleSearchResultArrayErrorMessage, __LINE__);
        }
        if (is_null($accountRecycleSearchResult) || (is_array($accountRecycleSearchResult) && empty($accountRecycleSearchResult))) {
            unset($this->AccountRecycleSearchResult);
        } else {
            $this->AccountRecycleSearchResult = $accountRecycleSearchResult;
        }
        return $this;
    }
    /**
     * Add item to AccountRecycleSearchResult value
     * @throws \InvalidArgumentException
     * @param \CustomerManagement\StructType\AccountRecycleSearchResult $item
     * @return \CustomerManagement\ArrayType\ArrayOfAccountRecycleSearchResult
     */
    public function addToAccountRecycleSearchResult(\CustomerManagement\StructType\AccountRecycleSearchResult $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \CustomerManagement\StructType\AccountRecycleSearchResult) {
            throw new \InvalidArgumentException(sprintf('The AccountRecycleSearchResult property can only contain items of type \CustomerManagement\StructType\AccountRecycleSearchResult, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AccountRecycleSearchResult[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \CustomerManagement\StructType\AccountRecycleSearchResult|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \CustomerManagement\StructType\AccountRecycleSearchResult|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \CustomerManagement\StructType\AccountRecycleSearchResult|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \CustomerManagement\StructType\AccountRecycleSearchResult|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \CustomerManagement\StructType\AccountRecycleSearchResult|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AccountRecycleSearchResult
     */
    public function getAttributeName()
    {
        return 'AccountRecycleSearchResult';
    }
}
